class ActionText:
    minimum_wait = 500

    def __init__(self, where, param):
        params = param.split(";")
        self._text = params[0]
        self._next_level = params[1]

    def on_init(self, systems):
        self._action = systems['action']
        self._writer = systems['writer']
        self._controller = systems['level_control']
        self._time = 0

    def update(self, dt):
        if self._time < ActionText.minimum_wait:
            self._time += dt
            self._action.set_action(self.on_action)

    def render(self, surface):
        if self._time > ActionText.minimum_wait:
            self._writer.write(surface, (20, 570), self._text)

    def on_action(self):
        self._action.set_action(None)
        self._controller.change_level(self._next_level)

