import pygame
from .comprectrenderer import RectRenderer


class Character:
    def __init__(self):
        self.position = (0, 0)
        self._collider = None

    def set_collider(self, collider):
        self._collider = collider

    def teleport(self, position):
        self.position = position

    def get_position(self):
        return self.position

    def _test_collision(self, position):
        if self._collider:
            x, y = position
            return self._collider.test_collision(pygame.Rect(x, y, 32, 32))

        return False

    def move(self, delta):
        (x, y) = self.position
        x += delta[0]
        y += delta[1]

        if not self._test_collision((x, y)):
            self.position = (x, y)


def get_character_renderer(character, color):
    return RectRenderer(character).color(color).size((32, 32))
