import pygame


class RectRenderer:
    def __init__(self, position_provider):
        self._position_provider = position_provider
        self._rect = pygame.Rect(0, 0, 0, 0)

    def color(self, color):
        self._color = color
        return self

    def size(self, size):
        self._size = size
        self._rect = pygame.Rect(self._rect.x, self._rect.y, size[0], size[1])
        return self

    def render(self, surface):
        x, y = self._position_provider.get_position()
        self._rect.x = x
        self._rect.y = y
        surface.fill(self._color, self._rect)
