import pygame
import level
from collider import StaticBoundingBlock

class EndLevel:
    def __init__(self, where, param):
        self._where = where
        self._next_level = param

    def on_init(self, systems):
        x, y = self._where
        fill_rect = pygame.Rect(x * level.BLOCK_WIDTH, y * level.BLOCK_HEIGHT,
                level.BLOCK_WIDTH, level.BLOCK_HEIGHT)
        block = StaticBoundingBlock(fill_rect, trigger = self.on_trigger)

        col = systems['collider']
        col.register_collidable(block)

        self.controller = systems['level_control']

    def on_trigger(self):
        self.controller.change_level(self._next_level)

    def update(self, dt):
        pass

