import pygame


class EventDispatcher:
    def __init__(self):
        self.key_actions = None

    def set_key_actions(self, actions):
        self.key_actions = actions

    def process(self, event):
        if event.type in [pygame.KEYUP, pygame.KEYDOWN]:
            action = self.key_actions.get((event.type, event.key), None)
            if action:
                action()
