import pygame
import level
from collider import StaticBoundingBlock


class Gate:
    def __init__(self, where, gate_type):
        self._where = where
        self._type = gate_type
        self._time = 0

    def on_init(self, systems):
        x, y = self._where
        fill_rect = pygame.Rect(x * level.BLOCK_WIDTH, y * level.BLOCK_HEIGHT,
                level.BLOCK_WIDTH, level.BLOCK_HEIGHT)
        block = StaticBoundingBlock(fill_rect, trigger = self.on_trigger)

        col = systems['collider']
        col.register_collidable(block)

        self._action = systems['action']
        self._character = systems['character']

    def on_trigger(self):
        self._action.set_action(self.on_action)
        self._time = 100

    def update(self, dt):
        if self._time > 0:
            self._time -= dt
            if self._time <= 0:
                self._action.set_action(None)

    def render(self, surface):
        x, y = self._where
        surface.fill((255, 255, 255), pygame.Rect(x * 32 + 4, y * 32 + 4, 24, 24))

    def on_action(self):
        x, y = self._where
        x += 1
        self._character.teleport(level.position_to_screen((x, y)))

