import pygame
import collider


class TriggeredText:
    number_of_texts = 0

    def __init__(self, where, text):
        self._where = where
        self._text = text
        self._bounding_box = pygame.Rect(where[0] * 32, where[1] * 32, 32, 32)
        self._timer = 0

    def on_init(self, systems):
        col = systems['collider']
        col.register_collidable(self)
        self._writer = systems['writer']

    def get_bounding_box(self):
        return self._bounding_box

    def get_collide_flags(self):
        return collider.TRIGGER

    def on_triggered(self):
        self._timer = 1000

    def update(self, dt):
        if self._timer > 0:
            self._timer -= dt
            TriggeredText.number_of_texts = 0

    def render(self, surface):
        if self._timer > 0:
            self._writer.write(surface, (20, 20 + TriggeredText.number_of_texts * 32), self._text)
            TriggeredText.number_of_texts += 1

